﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace SuperScooter
{
    public class Enemy1 : Collideable
    {
        public const int Y_DISPLACEMENT_FOR_TILE_GRAPHICS = 5;
        public const int HORIZONTAL_FRAME_GAP = 10;
        public const float SPRITE_DEFAULT_ALPHA = 1.0f;
        public const float SPRITE_ALPHA_CHANGE = 0.05f;

        private Vector2 position = Vector2.Zero;
        private Vector2 speed = new Vector2(-2.0f, 0.0f);
        private int WalkCount;
        private int Health;
        private bool isDead = false;
        private bool Direction = true;

        //private player H;

        private Game game;

        private const int MAX = 5;

        //Texture2D[] rightwardEnemy = new Texture2D[MAX];
        //Texture2D[] leftwardEnemy = new Texture2D[MAX];
        //Texture2D DeadEnemy;
        private Sprite enemySprite;
        private Texture2D spriteTexture;
        private Texture2D dummyTexture;


        private List<List<Tile>> tiles;
        Tile left = new Tile(null, CollideType.Passable, 0, 0);
        Tile right = new Tile(null, CollideType.Passable, 0, 0);

        private bool killing = false;

        //Constructor...     ---INCOMPLETE---
        //**************
        public Enemy1(Game game, Vector2 position, ref List<List<Tile>> tiles)
        {
            this.game = game;
            this.tiles = tiles;
            WalkCount = 0;
            Health = 1;
            LoadContent();
            Position(position);
        }


        #region:Load Content
        //Load Content...
        //****************
        public void LoadContent()
        {
            /*leftwardEnemy[0] = game.Content.Load<Texture2D>("Textures/eileft1");
            leftwardEnemy[1] = game.Content.Load<Texture2D>("Textures/eileft2");
            leftwardEnemy[2] = game.Content.Load<Texture2D>("Textures/eileft3");
            leftwardEnemy[3] = game.Content.Load<Texture2D>("Textures/eileft4");
            leftwardEnemy[4] = game.Content.Load<Texture2D>("Textures/eileft5");

            rightwardEnemy[0] = game.Content.Load<Texture2D>("Textures/eiright1");
            rightwardEnemy[1] = game.Content.Load<Texture2D>("Textures/eiright2");
            rightwardEnemy[2] = game.Content.Load<Texture2D>("Textures/eiright3");
            rightwardEnemy[3] = game.Content.Load<Texture2D>("Textures/eiright4");
            rightwardEnemy[4] = game.Content.Load<Texture2D>("Textures/eiright5");

            DeadEnemy = game.Content.Load<Texture2D>("Textures/Level1/bowser");

            avatar = leftwardEnemy[0];*/
            spriteTexture = game.Content.Load<Texture2D>("Textures/snake");
            dummyTexture = game.Content.Load<Texture2D>("Textures/snake_still");

            enemySprite = new Sprite(game, spriteTexture, Sprite.Direction.LEFT, Sprite.Direction.LEFT, Tile.SIZE, Tile.SIZE, HORIZONTAL_FRAME_GAP, 4, 3, -1);
            avatar = dummyTexture;
        }
        #endregion


        #region:Getters
        //Getters...
        //**********
        public Vector2 Position()
        {
            return position;
        }
        public Vector2 Speed()
        {
            return speed;
        }
        new public int Height()
        {
            return avatar.Height;
        }
        new public int Width()
        {
            return avatar.Width;
        }
        #endregion

        #region:Setters
        //Setters...
        //**********
        public void Position(Vector2 p)
        {
            position = p;
            SetPosition(p);
        }
        public void Speed(Vector2 s)
        {
            speed = s;
        }
        public void ChangeTexture(Texture2D tex)
        {
            //avatar = tex;
        }
        #endregion


        //Contains:
        //TakeHit, Die, Revive, Dead, Turn, Collided, CollidedTop, Me
        #region:Useful Functions
        /******************************************************
        TakeHit
         * Decreases Enemy's health by 1. Causes the Enemy to
         * die if health reaches zero.
        *******************************************************/
        public void TakeHit()
        {
            Health--;
            if (Health <= 0)
                Kill();//Die();
        }

        private void Kill()
        {
            killing = true;
            enemySprite.KillSprite();
            speed.X = 0; speed.Y = 0;
            shell = new Rectangle(0, 0, 0, 0);
        }

        /******************************************************
        Die
         * Causes Enemy to stop moving and to consider itself
         * dead.
        ******************************************************/
        public void Die()
        {
            //speed.X = 0; speed.Y = 0;
            isDead = true;
            //avatar = DeadEnemy;
        }

        /******************************************************
        Revive
         * Causes the Enemy to resume activity as if it were
         * alive.
        ******************************************************/
        public void Revive()
        {
            enemySprite.StandSprite();
            if (Direction)
                speed.X = -2;
            else
                speed.X = 2;
            //WalkCount = 0;
            isDead = false;
            Health = 1;
        }

        /******************************************************
        Dead
         * Returns true if Enemy considers itself dead.
        ******************************************************/
        public bool Dead()
        {
            return isDead;
        }

        /******************************************************
        Turn
         * Causes the Enemy to change the direction of its
         * movement.
        ******************************************************/
        public void Turn()
        {
            enemySprite.ChangeDirection();
            speed.X *= -1;
            WalkCount = 0;
            //if (speed.X <= 0)
            //    Direction = true;
            //else
            //    Direction = false;
        }

        /******************************************************
        Collided
         * Returns true if the Enemy has collided with the
         * Hero.
        ******************************************************/
        //private bool Collided()
        //{
        //    if (Collision(H))
        //        return true;
        //    else return false;
        //}

        /******************************************************
        Me
         * Returns a rectangle around the Enemy's graphic.
        ******************************************************/
        #endregion

        #region:Update
        //Update...
        //*********
        public void Update(GameTime gameTime, GraphicsDeviceManager g)
        {
            if (killing)
            {
                if (enemySprite.AlphaValue > 0)
                    enemySprite.AlphaValue -= SPRITE_ALPHA_CHANGE;
                else
                    Die();
            }
            else if (!isDead)
                enemySprite.ChangeState();

            int tilePositionX = (int)position.X / 40;
            int tilePositionY = (int)position.Y / 40;
            right = tiles[tilePositionX + 1][tilePositionY];
            left = tiles[tilePositionX - 1][tilePositionY];

            if (!killing && !isDead)
                Position(position + speed);

            if (shell.Intersects(right.BoundingRectangle) && right.collideType != CollideType.Passable)
                Turn();
            else if(shell.Intersects(left.BoundingRectangle) && left.collideType != CollideType.Passable)
                Turn();
        }
        #endregion

        #region:Draw
        /// <summary>
        /// Draws the enemy to the screen.
        /// </summary>
        /// <param name="sp">SpriteBatch for drawing.</param>
        /// <param name="CameraPosition">Level camera position.</param>
        public void Draw(SpriteBatch sp,  Point CameraPosition)
        {
            //sp.Draw(avatar, new Vector2(position.X - CameraPosition, ), Color.White);
            enemySprite.Draw(sp, (int)position.X - CameraPosition.X, (int)position.Y - CameraPosition.Y + Y_DISPLACEMENT_FOR_TILE_GRAPHICS);
        }
        #endregion
    }
}
