using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Storage;


namespace SuperScooter
{
    public class Tile : Collideable
    {
        public const int SIZE = 40;
        public CollideType collideType;

        public int Size
        {
            get { return SIZE; }
        }

        public Tile(Texture2D texture, CollideType collideType, int tilePositionX, int tilePositionY)
        {
            SetPosition(new Vector2(tilePositionX * SIZE, tilePositionY * SIZE));
            avatar = texture;
            this.collideType = collideType;
        }

        public Tile(Texture2D texture, CollideType collideType, int tilePositionX, int tilePositionY, Rectangle forcedShell)
        {
            //SetPosition(new Vector2(tilePositionX * SIDE, tilePositionY * SIDE));
            avatar = texture;
            shell = new Rectangle(forcedShell.Left + tilePositionX * SIZE,
                                    forcedShell.Top + tilePositionY * SIZE,
                                    forcedShell.Right + tilePositionX * SIZE,
                                    forcedShell.Bottom + tilePositionY * SIZE);
            this.collideType = collideType;
        }
    }
}